//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "updownclient.h"
#include "emule.h"
#include "uploadqueue.h"
#include "Clientlist.h"
#include "memcpy_amd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//--- xrmb:hashthieves1 ---
t_offensecounter offensecounter;
t_hashbase hashbase;
//--- :xrmb ---

//	members of CUpDownClient
//	which are used by down and uploading functions 

#ifdef OLD_SOCKETS_ENABLED
CUpDownClient::CUpDownClient(CClientReqSocket* sender){
	socket = sender;
	reqfile = 0;
	Init();
}
#endif //OLD_SOCKETS_ENABLED

// LANCAST (moosetea) isOnLAN returns true if lancast is enabled and this updownclient is on our subnet
//bool CUpDownClient::isOnLAN(){
//	EMULE_TRY
//
//	static bool bFirstTime= true;
//	static bool bIsOnLan = false; 
//
//		if (bFirstTime){
//			bFirstTime = false;
//			bIsOnLan = (theApp.glob_prefs->GetLancastEnabled() && ((theApp.glob_prefs->GetLancastIP()&theApp.glob_prefs->GetLancastSubnet()) == (m_dwUserIP&theApp.glob_prefs->GetLancastSubnet())));
//		}
//		return bIsOnLan;
//
//	EMULE_CATCH
//	return false;
//}

CUpDownClient::CUpDownClient(uint16 in_port, uint32 in_userid,uint32 in_serverip, uint16 in_serverport,CPartFile* in_reqfile){
#ifdef OLD_SOCKETS_ENABLED
	socket = 0;
#endif //OLD_SOCKETS_ENABLED
	Init();

	SetUserID(in_userid);
	m_nUserPort = in_port;
	sourcesslot=m_nUserID%SOURCESSLOTS;
	if (!HasLowID())
		m_szFullUserIP.Format(_T("%i.%i.%i.%i"),(uint8)m_nUserID,(uint8)(m_nUserID>>8),(uint8)(m_nUserID>>16),(uint8)(m_nUserID>>24));
	m_dwServerIP = in_serverip;
	m_nServerPort = in_serverport;
	reqfile = in_reqfile;
	ReGetClientSoft();
}

void CUpDownClient::Init(){
	EMULE_TRY
	m_szFullUserIP = "";
	credits = 0;
	m_LastPartAsked = 0xffff;		//jicxicmic
	m_nAvDownDatarate = 0;
	m_nAvUpDatarate = 0;
	m_Client_Sum_DL_DR_over_last_N_measurements = 0;
	m_Client_Sum_DL_tick_over_last_N_measurements = 0;
	m_TransferedInLastPeriod = 0;
	m_byChatstate = 0;
//	m_cShowDR = 0;
	m_nUDPPort = 0;
	m_cFailed = 0;
	m_dwBanTime = 0;
	m_nMaxSendAllowed = 0;
	m_nTransferedUp = 0;
	m_cAsked = 0;
	m_cDownAsked = 0;
	m_nUpDatarate = -1;
	m_pszUsername = "";
	m_dwUserIP = 0;
	SetUserID(0);
	m_nServerPort = 0;
	b_IsOnLan = false;
	m_bBanned = false;
	m_bFileListRequested = false;
	m_dwLastUpRequest = 0;
	m_bEmuleProtocol = false;
	usedcompressiondown = false;
	m_bUsedComprUp = false;
	m_bCompleteSource = false;
	m_bFriendSlot = false;
	m_bCommentDirty = false;
	m_bReaskPending = false;
	m_bUDPPending = false;
	m_byEmuleVersion = 0;
	m_modVerString = "";
	m_modExtendedString = "";
	m_nUserPort = 0;
	m_nPartCount = 0;
	m_nUpPartCount = 0;
	m_abyPartStatus = 0;
	m_abyUpPartStatus = 0;
	m_dwLastAskedTime = 0;
	m_nDownloadState = DS_NONE;
	m_dwUploadTime = 0;
	m_nTransferedDown = 0;
	m_nDownDatarate = 0;
	//m_nDownDataRateMS = 0;
	m_byUploadState = US_NONE;
	m_dwLastBlockReceived = 0;
	m_byEmuleVersion = 0;
	m_byDataCompVer = 0;
	m_dwDataPlusVers = 0;
	m_byUDPVer = 0;
	m_bySourceExchangeVer = 0;
	m_byAcceptCommentVer = 0;
	m_byExtendedRequestsVer = 0;
	m_byDataTarodVer = 0; // Added by Tarod
	m_nRemoteQueueRank = 0;
	m_dwLastSourceRequest = 0;
	m_dwLastSourceAnswer = 0;
	m_RemoteClientSpeed = 0;
	m_byCompatableClient = 0;
	m_bIsHybrid = false;
	m_awayMessageResendCount = 0; //<--enkeyDEV(kei-kun)
	m_bIsML=false;
	m_Friend = NULL;
	m_iRate=0;
	m_strComment="";
	m_LastGotULData = 0;
	m_clientSoft=SO_UNKNOWN;
	m_bRemoteQueueFull = false;
	md4clr(m_achUserHash);
	SetWaitStartTime();
	//By Maverick
	m_RemoteScore = 0; 
	m_RemoteRatio = 0;
	m_RemoteBaseModifier = 0;
	m_RemoteInfoAvaiable = false;
	m_RemoteCommunity = false;
	m_RemoteCommunityEnabled = false;
#ifdef OLD_SOCKETS_ENABLED
	if (socket){
		SOCKADDR_IN sockAddr;
		memset(&sockAddr, 0, sizeof(sockAddr));
		uint32 nSockAddrLen = sizeof(sockAddr);
		socket->GetPeerName((SOCKADDR*)&sockAddr,(int*)&nSockAddrLen);
		m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
		m_szFullUserIP = inet_ntoa(sockAddr.sin_addr);
	}
#endif //OLD_SOCKETS_ENABLED
	sourcesslot=0;
	m_nUpCompleteSourcesCount= 0; // netwolf: complete sources (zegzav) 13.05.03
	m_lastRefreshedULDisplay = ::GetTickCount();
	//m_lastCalculatedDownloadRate = ::GetTickCount();
	score_base_cached = false; 
	community_cached = false; 
	md4clr(reqfileid);

	m_last_l2hac_exec = 0;		//<<-- enkeyDEV(th1) -L2HAC-
	m_L2HAC_time = 0;			//<<-- enkeyDEV(th1) -L2HAC-
	m_l2hac_enabled = false;	//<<-- enkeyDEV(th1) -L2HAC- lowid side
	
	EMULE_CATCH
}

CUpDownClient::~CUpDownClient(){
	EMULE_TRY
	//Beep(400,5);
#if KEEP_BANNED_CLIENTS
	//SyruS log deletion of banned client
	if (m_bBanned && !theApp.glob_prefs->GetCMNotLog())
		//enable cm-logging and set breakpoint here to see from where (shift-f11) it's been deleted
		AddDebugLogLine(false,_T("Deleting banned client '%s' by releasing object"), GetUserName());
#endif
	theApp.clientlist->RemoveClient(this);
	if (m_Friend){
		m_Friend->m_LinkedClient = NULL;
		theApp.friendlist->RefreshFriend(m_Friend);
		m_Friend = NULL;
	}	
#ifdef OLD_SOCKETS_ENABLED
	if (socket){
		socket->client = 0;
		socket->Safe_Delete();
	}	
#endif //OLD_SOCKETS_ENABLED
	if (m_abyPartStatus)
	{
		delete[] m_abyPartStatus;
		m_abyPartStatus	=	0;
	}
	if (m_abyUpPartStatus)
	{
		delete[] m_abyUpPartStatus;
		m_abyUpPartStatus	=	0;
	}
	ClearUploadBlockRequests();

	while(!m_DownloadBlocks_list.IsEmpty())
		delete m_DownloadBlocks_list.RemoveHead();
	while(!m_RequestedFiles_list.IsEmpty())
		delete m_RequestedFiles_list.RemoveHead();
	while(!m_PendingBlocks_list.IsEmpty()){
		Pending_Block_Struct *pending = m_PendingBlocks_list.RemoveHead();
		delete pending->block;
		// Not always allocated
		if (pending->zStream) {
			inflateEnd(pending->zStream);
			delete pending->zStream;			
		}
		delete pending;
	}

	if (m_iRate>0 || m_strComment.GetLength()>0) {
		m_iRate=0; m_strComment="";
		reqfile->UpdateFileRatingCommentAvail();
	}

	m_AverageUDR_list.clear();
	m_Average_DL_DR_list.clear();
#ifdef OLD_SOCKETS_ENABLED
	DEBUG_ONLY (theApp.listensocket->Debug_ClientDeleted(this));
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}

void CUpDownClient::ProcessHelloPacket(char* pachPacket, uint32 nSize){
	EMULE_TRY
	CSafeMemFile data((BYTE*)pachPacket,nSize);	
	uint8 hashsize;
	data.Read(&hashsize,1);
	ProcessHelloTypePacket(data);	
	EMULE_CATCH
}

void CUpDownClient::ProcessHelloAnswer(char* pachPacket, uint32 nSize){
	EMULE_TRY
	CSafeMemFile data((BYTE*)pachPacket,nSize);
	ProcessHelloTypePacket(data);	
	EMULE_CATCH
}

void CUpDownClient::ProcessHelloTypePacket(CSafeMemFile& data){
	EMULE_TRY
	m_bIsHybrid = false;
	m_bIsML = false;
	data.Read(&m_achUserHash,16);
	uint32 nUserID;
	data.Read(&nUserID,4);
	if (!m_nUserID)
		SetUserID(nUserID);
	data.Read(&m_nUserPort,2); // hmm clientport is sent twice - why?
	uint32	tagcount;
	data.Read(&tagcount,4);
	CString crash = _T("[Invalid user name]"); //Vorlost
	bool crashed = false; //Vorlost    
	bool wrong_port = false; // obaldin
	CTag* temptag;	//eklmn: small tag optimization to prevent memleaks
	for (uint32 i = 0;i < tagcount; i++)
	{
		temptag = new CTag(data);	//eklmn: small tag optimization to prevent memleaks
		switch(temptag->GetSpecialTag())
		{
			case CT_NAME:				
				if (temptag->GetStringValue().IsEmpty())
				{
					crashed = true; 
					uchar crashash[16]; 
					#ifndef AMD
					md4cpy(crashash,m_achUserHash);
					#else
					memcpy_amd(crashash,m_achUserHash,16);
					#endif
					CString buffer = FileHashToString(crashash);					
					AddDebugLogLine(false,_T("Invalid user name received! Userhash:%s, IP:%s, Userport:%d"),buffer,m_szFullUserIP,m_nUserPort);
					m_pszUsername = crash;
				}
				else
					m_pszUsername = temptag->GetStringValue();
				break;
			case CT_VERSION:
				m_nClientVersion = temptag->GetIntValue();
				break;
			case CT_PORT:
				if ( temptag->GetIntValue() != m_nUserPort && GetClientSoft() != SO_EDONKEYHYBRID ) 
				{
					wrong_port = true;
				}
				break;
			case CT_FRIENDSHARING:
			case CT_UNKNOWNx0:
			case CT_UNKNOWNx12:
			case CT_UNKNOWNx13:
			case CT_UNKNOWNx14:
			case CT_UNKNOWNx15:
			case CT_UNKNOWNx16:
			case CT_UNKNOWNx17:
			case CT_UNKNOWNx22:
			case CT_UNKNOWNx63:
			case CT_UNKNOWNx64:
			case CT_UNKNOWNx69:
			case CT_UNKNOWNx88:
			case CT_UNKNOWNx8c:
			case CT_UNKNOWNx8d:
			case CT_UNKNOWNx99:
				break;
			default:
			{                    
				if(!temptag->GetStringValue().IsEmpty()) 
				{
					CString buffer = temptag->GetStringValue();
					TagToDebugLogLine(_T("Hello: Unknown eDonkey tag"), buffer, buffer.GetLength(), temptag->GetSpecialTag());	// DbT:Logging
				}
				AddDebugLogLine(false,_T("Hello: Unknown eDonkey tag: 0x%x, Intvalue: %d Stringvalue: %s, (client version:%d) %s"),
					temptag->GetSpecialTag(), temptag->GetIntValue(), temptag->GetStringValue(), m_nClientVersion,
					m_pszUsername);
			}
		}
		delete temptag;
		temptag = NULL;	//eklmn: small tag optimization to prevent memleaks
	}
	data.Read(&m_dwServerIP,4);
	data.Read(&m_nServerPort,2);

	// Hybrid now has an extra uint32.. What is it for?
	// Also, many clients seem to send an extra 6? These are not eDonkeys or Hybrids..
	if ( data.GetLength() - data.GetPosition() == 4 ){
		uint32 test;
		data.Read(&test,4);
		if (test=='KDLM') 
			m_bIsML=true;
		else{
			m_bIsHybrid = true;
			//m_fSharedDirectories = 1;  These arent supported in Plus YET
		}
	}
	// 7/03/2003 [moosetea] Is this commented out for a reason? it cleans up client version numbers, specifically hybrids in the main client
	//if( m_nClientVersion > 10000 && m_nClientVersion < 100000 )
	//	m_nClientVersion = m_nClientVersion - (m_nClientVersion/10000)*10000;
	//if( m_nClientVersion > 1000 )
	//	m_nClientVersion = m_nClientVersion - (m_nClientVersion/1000)*1000;
	//if( m_nClientVersion < 100 )
	//	m_nClientVersion *= 10;

#ifdef OLD_SOCKETS_ENABLED
    if(wrong_port && !m_bIsHybrid) {
        CString ip_addr;
        UINT port;
        socket->GetPeerName(ip_addr, port);
        AddDebugLogLine(false,_T("User %s (client version:%d) IP:%s sent an incorrect user port. Used the real one instead: %d."),m_pszUsername,m_nClientVersion, ip_addr,m_nUserPort );
	}
#endif //OLD_SOCKETS_ENABLED

	SOCKADDR_IN sockAddr;
	memset(&sockAddr, 0, sizeof(sockAddr));
	uint32 nSockAddrLen = sizeof(sockAddr);
#ifdef OLD_SOCKETS_ENABLED
	socket->GetPeerName((SOCKADDR*)&sockAddr,(int*)&nSockAddrLen);
#endif //OLD_SOCKETS_ENABLED
	m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
	m_szFullUserIP = inet_ntoa(sockAddr.sin_addr);

	// If lancast is enabled check to see if this client is on the LAN
	b_IsOnLan = ((theApp.glob_prefs->GetLancastEnabled()) && ((theApp.glob_prefs->GetLancastIP()&theApp.glob_prefs->GetLancastSubnet()) == (m_dwUserIP&theApp.glob_prefs->GetLancastSubnet())));
	if (b_IsOnLan)
		m_nUserID = m_dwUserIP;

	// if (crashed) AddDebugLogLine(false,_T("The invalid user name was sent from IP:%s"), m_szFullUserIP);

	// get client credits
	if (theApp.glob_prefs->GetAddServersFromConn() && !crashed){  // obaldin: we shouldn't trust the client who tried to crash us
		in_addr addhost;
		addhost.S_un.S_addr = m_dwServerIP;
		CServer* addsrv = new CServer(m_nServerPort, CString(inet_ntoa(addhost)));
		addsrv->SetListName(addsrv->GetAddress());

		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(addsrv, true))
			delete addsrv;
		/*else
			AddLogLine(false,"Added new server: %s:%d", srv->GetFullIP(), srv->GetPort());*/
	}

	// Make sure if this user is a highid user there userid matches there ip address
	if(!HasLowID() && m_nUserID != m_dwUserIP)
		SetUserID(m_dwUserIP);

	uchar key[16];
	md4cpy(key,m_achUserHash);
	credits = theApp.clientcredits->GetCredit(key);
	if ((m_Friend = theApp.friendlist->LinkFriend(key, m_dwUserIP, m_nUserPort) ) != NULL){
		m_Friend->m_LinkedClient = this;
		m_Friend->m_dwHasHash = 1;
		for( int i = 0; i < 16; i++ )
			m_Friend->m_abyUserhash[i] = GetUserHash()[i];
		m_Friend->m_strName.Format(_T("%s"), m_pszUsername);
		m_Friend->m_dwLastUsedIP = m_dwUserIP;
		m_Friend->m_nLastUsedPort = m_nUserPort;
		theApp.friendlist->RefreshFriend(m_Friend);
		if(m_byChatstate==MS_CONNECTING)
		{
			TCITEM newitem;
			newitem.mask = TCIF_TEXT;
			newitem.pszText = m_pszUsername.GetBuffer(256);
			theApp.emuledlg->chatwnd.chatselector.SetItem(theApp.emuledlg->chatwnd.chatselector.GetTabByClient(this),&newitem);
		}
	}
	ReGetClientSoft();
	//--- xrmb:hashthieves1 ---
	//--- detectmystolenhash ---
	uint64 id=getUID();
	uint32 last_actions = 0;
	uint32 i_TotalClients = 0;
	uint32 i_TotalClientActions = 0;
	uint32 i_TotalActions = offensecounter[0];
	if (offensecounter.Lookup(id, i_TotalClientActions))
		i_TotalClients = offensecounter.GetSize()-1;
	else
		i_TotalClients = offensecounter.GetSize();
	// now start to check actions
	if(theApp.serverconnect->GetClientID()!=m_nUserID && md4cmp(m_achUserHash, theApp.glob_prefs->GetUserHash())==0 && theApp.glob_prefs->GetMlDonkeyCM())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHIMP));
		hashthief=true;
		last_actions++;
		i_TotalActions++;

		AddDebugLogLine(false, _T("Client '%s' uses my hash, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total/%i clients)!"), m_pszUsername,
			(uint8)m_dwUserIP, (uint8)(m_dwUserIP>>8), (uint8)(m_dwUserIP>>16),(uint8)(m_dwUserIP>>24), m_nUserPort, (i_TotalClientActions + last_actions), i_TotalActions, i_TotalClients);
	}

	//--- detect id-changer ---
	uint64 lasthash;
	uint64 thishash=0;
	for(int i = 0; i < 8; i++ )
		thishash += GetUserHash()[i] << (i*8) ^ GetUserHash()[i+8] << (i*8);
	if (hashbase.Lookup(id, lasthash) && lasthash!=thishash)
	{
		hashthief=true;
		last_actions++;
		i_TotalActions++;

		AddDebugLogLine(false, _T("Client '%s' changed hash, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total/%i clients)!"), m_pszUsername,
			(uint8)m_dwUserIP, (uint8)(m_dwUserIP>>8), (uint8)(m_dwUserIP>>16),(uint8)(m_dwUserIP>>24), m_nUserPort, (i_TotalClientActions + last_actions), i_TotalActions, i_TotalClients);
	}
	hashbase[id]=thishash;

	//--- famous stolen hashs/names ---
	if(IsStolenName())
	{
		hashthief=true;
		last_actions++;
		i_TotalActions++;

		theApp.emuledlg->AddDebugLogLine(false, _T("Client '%s' is known for cheating, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total)!"), m_pszUsername,
						(uint8)m_dwUserIP, (uint8)(m_dwUserIP>>8), (uint8)(m_dwUserIP>>16),(uint8)(m_dwUserIP>>24), m_nUserPort, (i_TotalClientActions + last_actions), i_TotalActions);
	}

	if((i_TotalClientActions + last_actions)>=3 && theApp.glob_prefs->GetMlDonkeyCM())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHSTEAL));
	}

	if (last_actions != 0) {
		offensecounter[id]=i_TotalClientActions + last_actions;
		offensecounter[0] = i_TotalActions;
	}
	//--- :xrmb ---

	EMULE_CATCH
}

bool CUpDownClient::IsStolenName() const
{
	EMULE_TRY
	if(!m_pszUsername.IsEmpty() && (
	//--- equals ---
		m_pszUsername == "pbwll" ||
		m_pszUsername == "unix user" ||

	//--- begins with ---
		m_pszUsername.Find("Odin") == 0 ||		
		m_pszUsername.Find("$GAM3R$") == 0 ||
		m_pszUsername.Find("G@m3rs Edit") == 0 ||
		m_pszUsername.Find("G@m3rs Edit") == 0 ||
		m_pszUsername.Find("[RAMMSTEIN") == 0 ||
		m_pszUsername.Find("[toXic]") == 0 ||
		m_pszUsername.Find("Leecha") == 0 ||
		m_pszUsername.Find("leecha") == 0 ||
		m_pszUsername.Find("eDevil") == 0 ||
		m_pszUsername.Find("darkmule") == 0 ||
		m_pszUsername.Find("DarkMule") == 0 ||
		m_pszUsername.Find("eVortex") == 0 ||
		m_pszUsername.Find("|eVorte|X|") == 0 ||
		m_modVerString.Find("eVortex") != -1 ||
		m_pszUsername.Find("MISON") == 0 ||
		m_pszUsername.Find("Mison") == 0 ||
		m_modVerString.Find("Mison") != -1))
		return true;
	EMULE_CATCH
	return false;
}

//v:- eklmn: do something if there is a socket
void CUpDownClient::SendHelloPacket(){
	EMULE_TRY
	// if IP is filtered, dont greet him but disconnect...
#ifdef OLD_SOCKETS_ENABLED
	if (socket){
		SOCKADDR_IN sockAddr;
		memset(&sockAddr, 0, sizeof(sockAddr));
		uint32 nSockAddrLen = sizeof(sockAddr);
		socket->GetPeerName((SOCKADDR*)&sockAddr,(int*)&nSockAddrLen);
		//eklmn: check at this place is removed. new check in TryToConnect
		/*
		if ( theApp.ipfilter->IsFiltered(sockAddr.sin_addr.S_un.S_addr)) 
		{
			AddDebugLogLine(false,_T("Filtered (HelloPacket): %s %s"), GetFullIP(),theApp.ipfilter->GetLastHit());
			Disconnected();
			theApp.stat_filteredclients++;
			return;
		}
		*/
		CMemFile data;
		uint8 hashsize = 16;
		data.Write(&hashsize,1);
		SendHelloTypePacket(data);
		Packet* packet = new Packet(&data);
		packet->opcode = OP_HELLO;
		theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
		socket->SendPacket(packet,true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::SendMuleInfoPacket(bool bAnswer){
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (socket)
	{
		CMemFile data;
		uint8 version = CURRENT_VERSION_SHORT;
		data.Write(&version,1);
		uint8 protversion = EMULE_PROTOCOL;
		data.Write(&protversion,1);
		uint32 tagcount = 10;
		data.Write(&tagcount,4);
		CTag tag(ET_COMPRESSION,1);
		tag.WriteTagToFile(data);
		CTag tag2(ET_UDPVER,3);	// netwolf: complete sources UDP
		tag2.WriteTagToFile(data);
		CTag tag3(ET_UDPPORT,theApp.glob_prefs->GetUDPPort());
		tag3.WriteTagToFile(data);
		CTag tag4(ET_SOURCEEXCHANGE,1);
		tag4.WriteTagToFile(data);
		CTag tag5(ET_COMMENTS,1);
		tag5.WriteTagToFile(data);
		CTag tag6(ET_MOD_TAROD, 1);						// To check for Tarod/Plus (just curiosity)
		tag6.WriteTagToFile(data);	// It do not harms at all (!)
		CTag tag7(ET_MOD_PLUS, CURRENT_PLUS_VERSION);	// To check for eMulePlus
		tag7.WriteTagToFile(data);	                    // It doesn't do any harm (?)
		CTag tag8(ET_EXTENDEDREQUEST,1);
		tag8.WriteTagToFile(data);
		CTag tag9(ET_MOD_VERSION, _T(PLUS_VERSION_STR));
		tag9.WriteTagToFile(data);	 //More harmless than the other 2! :D
		CTag tag10(ET_L2HAC,FILEREASKTIME);	//<<-- enkeyDEV(th1) -L2HAC-
		tag10.WriteTagToFile(data);			//<<-- enkeyDEV(th1) -L2HAC-
		Packet* packet = new Packet(&data,OP_EMULEPROT);
		if (!bAnswer)
			packet->opcode = OP_EMULEINFO;
		else
			packet->opcode = OP_EMULEINFOANSWER;

		theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
		socket->SendPacket(packet,true,true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::ProcessMuleInfoPacket(char* pachPacket, uint32 nSize){
	EMULE_TRY
	CSafeMemFile data((BYTE*)pachPacket,nSize);
	m_byCompatableClient = 0;
	data.Read(&m_byEmuleVersion,1);
	if( m_byEmuleVersion == 0x2B )
		m_byEmuleVersion = 0x22;
	uint8 protversion;
	data.Read(&protversion,1);

	//implicitly supported options by older clients
	if (protversion == EMULE_PROTOCOL) 
    {
		//in the future do not use version to guess about new features

		if(m_byEmuleVersion < 0x25 && m_byEmuleVersion > 0x22)
			m_byUDPVer = 1;

		if(m_byEmuleVersion < 0x25 && m_byEmuleVersion > 0x21)
			m_bySourceExchangeVer = 1;

		if(m_byEmuleVersion == 0x24)
			m_byAcceptCommentVer = 1;

	} else {		
		return;
	}
	m_bEmuleProtocol = true;

	m_L2HAC_time = 0;	//<<-- enkeyDEV(th1) -L2HAC-

	uint32 tagcount = 0;
	data.Read(&tagcount,4);
	for (uint32 i = 0;i < tagcount; i++){
		CTag* temptag = new CTag(data);
		switch(temptag->GetSpecialTag()){
			case ET_COMPRESSION:
				m_byDataCompVer = temptag->GetIntValue();
				break;
			case ET_UDPPORT:
				m_nUDPPort = temptag->GetIntValue();
				break;
			case ET_UDPVER:
				m_byUDPVer = temptag->GetIntValue();
				break;
			case ET_SOURCEEXCHANGE:
				m_bySourceExchangeVer = temptag->GetIntValue();
				break;
			case ET_COMMENTS:
				m_byAcceptCommentVer = temptag->GetIntValue();
				break;
			case ET_EXTENDEDREQUEST:
				m_byExtendedRequestsVer = temptag->GetIntValue();
				break ;
			case ET_COMPATABLECLIENT:
				m_byCompatableClient = temptag->GetIntValue();
				break;
			case ET_MOD_FEATURESET:
                break;
            case ET_MOD_VERSION:                
                m_modVerString = temptag->GetStringValue();
                break;
            case ET_MOD_PROTOCOL:				
				m_modExtendedString = temptag->GetStringValue();
				break;
            case ET_MOD_PLUS:
                m_dwDataPlusVers = temptag->GetIntValue();
                break ;
            case ET_MOD_TAROD:
				m_byDataTarodVer = temptag->GetIntValue();
				break;
			case ET_MOD_BOWLFISH:
			case ET_MOD_TAROD_VERSION:
			case ET_MOD_FUSION:
			case ET_MOD_FUSION_VERSION:
			case ET_MOD_Morph:
			case ET_MOD_Morph_VERSION:
			case ET_MOD_MorTillo:
			case ET_MOD_MorTillo_VERSION:
            case ET_MOD_LSD:
            case ET_MOD_LSD_VERSION:
			case ET_MOD_LOVELACE_VERSION:
            case ET_MOD_OXY:
				break;
			case ET_L2HAC:	// START enkeyDEV(th1) -L2HAC-
				m_L2HAC_time = temptag->GetIntValue();
				break;		// END enkeyDEV(th1) -L2HAC-
			case ET_INCOMPLETEPARTS: // enkeyDEV(th1) -ICS-
			   	break;
			case ET_FEATURES:	// secure credits (official 0.29b)
				break;
			case ET_MOD_UNKNOWNx12:
			case ET_MOD_UNKNOWNx13:
			case ET_MOD_UNKNOWNx14:
			case ET_MOD_UNKNOWNx17:
			case ET_MOD_UNKNOWNx41:
			case ET_MOD_UNKNOWNx42:
			case ET_MOD_UNKNOWNx43:
			case ET_MOD_UNKNOWNx5C:
			case ET_MOD_UNKNOWNx64:
			case ET_MOD_UNKNOWNx76:
			case ET_MOD_UNKNOWNx85:
			case ET_MOD_UNKNOWNx86:
			case ET_MOD_UNKNOWNx91:
			case ET_MOD_UNKNOWNx92:
			case ET_MOD_UNKNOWNx93:
			case ET_MOD_UNKNOWNxA0:
			case ET_MOD_UNKNOWNxDA:
			   	break;
			default:
                {                    
                    if(!temptag->GetStringValue().IsEmpty()) {
                        CString buffer = temptag->GetStringValue();
						TagToDebugLogLine(_T("Process: Unknown eMule tag"), buffer, buffer.GetLength(), temptag->GetSpecialTag());	// DbT:Logging
                    }
					AddDebugLogLine(false,_T("Process: Unknown eMule tag: 0x%x, Intvalue: %d Stringvalue: %s User: %s(%s)"),
                        temptag->GetSpecialTag(), temptag->GetIntValue(), temptag->GetStringValue(), m_pszUsername,GetClientNameAndVersionString(this) );
                }
		}
		delete temptag;
	}

	// START enkeyDEV(th1) -L2HAC- Enable every emule anyway and disable bad clients
	if (!m_L2HAC_time) m_L2HAC_time = L2HAC_DEFAULT_EMULE;
	if (m_L2HAC_time < L2HAC_MIN_TIME || m_L2HAC_time > L2HAC_MAX_TIME) m_L2HAC_time = 0;
	// END enkeyDEV(th1) -L2HAC-

	if( m_byDataCompVer == 0 ){
		m_bySourceExchangeVer = 0;
		m_byExtendedRequestsVer = 0;
		m_byAcceptCommentVer = 0;
		m_nUDPPort = 0;
		m_L2HAC_time = 0;	//<<-- enkeyDEV(th1) -L2HAC-
	}	
	//ReGetClientSoft();	// 9/5/2003 [Moosetea] Official client, this messes the stats up, creates lots of invalid edonkey clients
	EMULE_CATCH
}

void CUpDownClient::SendHelloAnswer(){
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (socket)
	{
		CMemFile data;
		SendHelloTypePacket(data);
		Packet* packet = new Packet(&data);	
		packet->opcode = OP_HELLOANSWER;
		theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
		socket->SendPacket(packet,true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::SendHelloTypePacket(CMemFile& data){
	EMULE_TRY
	// By Maverick
	// Emulate eDonkey or MlDonkey in case of a connection to a MlDonkey
	// This patch is introduced to conteract the MlDonkey's politics against 
	// eMule. (eMules can only occupy 1/3 of the upload queue of a MlDonkey)
	uchar hash[16];
	#ifndef AMD
	md4cpy(hash,theApp.glob_prefs->GetUserHash());
	#else
	memcpy_amd(hash,theApp.glob_prefs->GetUserHash(),16);
	#endif
	// Checking for MLDonkey does not help anymore since they have removed this feature so 
	// we emulate now an eDonkey to all except eMule. Note do not loose a word about this
	// in any forum. Otherwise we have to adapt to them again.
    // Does not help anymore either mlDonkey uses eMule type userhashes
    // Furthermore the servers have a problem with this feature so I had to go back to 
    // emulating only with MlDonkey
	if (GetClientSoft() == SO_MLDONKEY && theApp.glob_prefs->GetMlDonkeyCM())		//Cax2 only if enabled
	{
		while ((hash[5] == 14) && (hash[14] = 111))
		{
			uint8	random = rand();
			#ifndef AMD
			memcpy(&hash[5],&random,1);
			random = rand();
			memcpy(&hash[14],&random,1);
			#else
			memcpy_amd(&hash[5],&random,1);
			random = rand();
			memcpy_amd(&hash[14],&random,1);
			#endif
		}
	}
	data.Write(hash,16);
	// END Patch Maverick
#ifdef OLD_SOCKETS_ENABLED
	uint32 clientid = theApp.serverconnect->GetClientID();
	data.Write(&clientid,4);
#endif //OLD_SOCKETS_ENABLED
	uint16 nPort = theApp.glob_prefs->GetListenPort();  //Maverick
	data.Write(&nPort,2);
	uint32 tagcount = 2;
	data.Write(&tagcount,4);
	CTag* tag = new CTag(CT_NAME,theApp.glob_prefs->GetUserNick().GetBuffer());
	tag->WriteTagToFile(data);
	delete tag;
	tag = new CTag(CT_VERSION,EDONKEYVERSION);
	tag->WriteTagToFile(data);
	delete tag;
//	tag = new CTag(CT_PORT,nPort); //Maverick
//	tag->WriteTagToFile(data);
//	delete tag;
	uint32 dwIP;
#ifdef OLD_SOCKETS_ENABLED
	if (theApp.serverconnect->IsConnected()){
		dwIP = theApp.serverconnect->GetCurrentServer()->GetIP();
		nPort = theApp.serverconnect->GetCurrentServer()->GetPort();
	}
	else
#endif //OLD_SOCKETS_ENABLED
	{
		nPort = 0;
		dwIP = 0;
	}
	data.Write(&dwIP,4);
	data.Write(&nPort,2);
	EMULE_CATCH
}

void CUpDownClient::ProcessMuleCommentPacket(char* pachPacket, uint32 nSize){
	EMULE_TRY
	if ((reqfile != NULL) && (nSize > 2)){
		CSafeMemFile data((BYTE*)pachPacket,nSize);
		int length;
		data.Read(&m_iRate,sizeof(m_iRate));
		data.Read(&length,sizeof(length));        
		if (length>50) length=50;
		if (length>0){			
			data.Read(m_strComment.GetBuffer(length+1),length);
			m_strComment.ReleaseBuffer(length);
			//(SyruS) netwolf commentfilter
			CString strList(theApp.glob_prefs->GetCommentFilter().MakeLower());
			if (!strList.IsEmpty()) {
				CString lowComment(m_strComment);	//make a copy of casesensitive comment
				lowComment.MakeLower();				//make copy only lowercase to search in
				int curPos = 0;
				CString resToken(strList.Tokenize(_T("|"),curPos));
				while (!resToken.IsEmpty()) {
					if (lowComment.Find(resToken)>-1) {
						AddDebugLogLine(false, _T("Description for file '%s' filtered: %s"), m_strClientFilename, m_strComment);
						m_strComment="";
						m_iRate=0;
						break;
					}
					resToken = strList.Tokenize(_T("|"),curPos);
				}
			}
			if (!m_strComment.IsEmpty())
			{
				reqfile->SetHasComment(true);
				AddDebugLogLine(false, _T("Description for file '%s' received: %s"), m_strClientFilename, m_strComment);
			}			
		}
		if (m_iRate != 0) {
			reqfile->SetHasRating(true);
			AddDebugLogLine(false, _T("Rating for file '%s' received: %i"), m_strClientFilename, m_iRate);
		}
	}
	//SyruS imho we do not have to update display manual at all - it's updated a sec later automaticly
	//if (reqfile->HasRating() || reqfile->HasComment()) theApp.emuledlg->transferwnd.downloadlistctrl.UpdateItem(reqfile);
	EMULE_CATCH
}

void CUpDownClient::Disconnected(){
	EMULE_TRY
    if(!theApp.clientlist->Debug_IsValidClient(this)) { // obaldin: a quick fix for a strange bug
        AddDebugLogLine(false, _T("Invalid client in CUpDownClient::Disconnected"));
        return;
    }
	ASSERT(theApp.clientlist->Debug_IsValidClient(this));
	if (GetUploadState() == US_UPLOADING)
		theApp.uploadqueue->RemoveFromUploadQueue(this);
	if (GetDownloadState() == DS_DOWNLOADING)
		SetDownloadState(DS_ONQUEUE);
	if ((GetDownloadState() == DS_REQHASHSET) && (reqfile))
        reqfile->hashsetneeded= true;
	ASSERT(theApp.clientlist->Debug_IsValidClient(this));
	//check if this client is needed in any way, if not delete it
	bool bDelete = true;
	switch(m_byUploadState){
		case US_ONUPLOADQUEUE:
			bDelete = false;
	};
	switch(m_nDownloadState){
		case DS_ONQUEUE:
		case DS_TOOMANYCONNS:
		case DS_NONEEDEDPARTS:
		case DS_LOWTOLOWIP:
			bDelete = false;
	};

	switch(m_byUploadState){
		case US_CONNECTING:
		case US_WAITCALLBACK:
		case US_ERROR:
			bDelete = true;
	};
	switch(m_nDownloadState){
		case DS_CONNECTING:
		{
			m_cFailed++;
			if (m_cFailed <= 2){
				TryToConnect();
				return;
			}
		}
		case DS_WAITCALLBACK:
		case DS_ERROR:
			bDelete = true;
	};
#if KEEP_BANNED_CLIENTS
	//SyruS no deletion of banned client //this works...
	if (m_bBanned)
	{
		bDelete = false;
		if (!theApp.glob_prefs->GetCMNotLog())
			AddDebugLogLine(false,_T("Keeping banned client '%s' after disconnect"), GetUserName());
	}
#endif
	if (GetChatState() != MS_NONE){	//SyruS (0.29c)
		bDelete = false;
		theApp.emuledlg->chatwnd.chatselector.ConnectingResult(this,false);
	}
#ifdef OLD_SOCKETS_ENABLED
	if (socket){
		ASSERT (theApp.listensocket->IsValidSocket(socket));
		socket->Safe_Delete();
	}
	socket = 0;
#endif //OLD_SOCKETS_ENABLED
	if (m_bFileListRequested){
		AddDebugLogLine(false,IDS_SHAREDFILES_FAILED,GetUserName());
		m_bFileListRequested = false;
	}
	if (m_Friend)
		theApp.friendlist->RefreshFriend(m_Friend);
	if (bDelete){
		delete this;
	}
	EMULE_CATCH
}

bool CUpDownClient::TryToConnect(bool bIgnoreMaxCon){
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (theApp.listensocket->TooManySockets() && !bIgnoreMaxCon && !(socket && socket->IsConnected())){
		Disconnected();
		return false;
	}
	if ((theApp.serverconnect->GetClientID() < 16777216) && HasLowID()){
		if (GetDownloadState() == DS_CONNECTING)
			SetDownloadState(DS_LOWTOLOWIP);
		else if (GetDownloadState() == DS_REQHASHSET){
			SetDownloadState(DS_ONQUEUE);
			reqfile->hashsetneeded = true;
		}
		if (GetUploadState() == US_CONNECTING){
			Disconnected();
			return false; // SLUGFILLER: SafeDisconnect	//SyruS (0.29c) ouch! this was 2 lines down
		}
	}
#endif //OLD_SOCKETS_ENABLED

#ifdef OLD_SOCKETS_ENABLED
	if (!socket){
		socket = new CClientReqSocket(theApp.glob_prefs,this);
		if (!socket->Create()){
			socket->Safe_Delete();
			return true;	// SLUGFILLER: SafeDisconnect
		}
	}
	else if (!socket->IsConnected()){
		socket->Safe_Delete();
		socket = new CClientReqSocket(theApp.glob_prefs,this);
		if (!socket->Create()){
			socket->Safe_Delete();
			return true;	// SLUGFILLER: SafeDisconnect
		}
	}
	else{
		ConnectionEstablished();
		return true;	// SLUGFILLER: SafeDisconnect
	}
#endif //OLD_SOCKETS_ENABLED
	// MOD Note: Do not change this part - Merkur
	if (HasLowID()){
		if (GetDownloadState() == DS_CONNECTING)
			SetDownloadState(DS_WAITCALLBACK);
		if (GetUploadState() == US_CONNECTING){
			Disconnected();
			return false;	// SLUGFILLER: SafeDisconnect
		}

#ifdef OLD_SOCKETS_ENABLED
		if (theApp.serverconnect->IsLocalServer(m_dwServerIP,m_nServerPort)){
			Packet* packet = new Packet(OP_CALLBACKREQUEST,4);
			#ifndef AMD
			memcpy(packet->pBuffer,&m_nUserID,4);
			#else
			memcpy_amd(packet->pBuffer,&m_nUserID,4);
			#endif
			theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
			theApp.serverconnect->SendPacket(packet);
		}
		else
		{
			if (GetUploadState() == US_NONE && (!GetRemoteQueueRank() || m_bReaskPending) )
			{
				theApp.downloadqueue->RemoveSource(this);
				Disconnected();
				return false;	// SLUGFILLER: SafeDisconnect
			}
			else
			{
				if (GetDownloadState() == DS_WAITCALLBACK)
				{
					m_bReaskPending = true;
					SetDownloadState(DS_ONQUEUE);
				}
			}
		}
#endif //OLD_SOCKETS_ENABLED
	}
	// MOD Note - end
	else
	{
		if ( theApp.ipfilter->IsFiltered(m_nUserID)) 
		{
			AddDebugLogLine(false,_T("Filtered (don't connect): %s %s"), GetFullIP(),theApp.ipfilter->GetLastHit());
			theApp.downloadqueue->RemoveSource(this);
			if (socket)
				socket->Safe_Delete();
			theApp.stat_filteredclients++;
			return false;
		}
#ifdef OLD_SOCKETS_ENABLED
		socket->Connect(GetFullIP(),GetUserPort());
#endif //OLD_SOCKETS_ENABLED
		SendHelloPacket();
	}
	return true;	// SLUGFILLER: SafeDisconnect
	
	EMULE_CATCH
	return false;
}

void CUpDownClient::ConnectionEstablished(){
	EMULE_TRY
	m_cFailed = 0;
	// ok we have a connection, lets see if we want anything from this client
	if (GetChatState() == MS_CONNECTING)
		theApp.emuledlg->chatwnd.chatselector.ConnectingResult(this,true);
	switch(GetDownloadState()){
		case DS_CONNECTING:
		case DS_WAITCALLBACK:
			m_bReaskPending = false;
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
	}
	if (m_bReaskPending){
		m_bReaskPending = false;
		if (GetDownloadState() != DS_NONE && GetDownloadState() != DS_DOWNLOADING){
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
		}
	}
	switch(GetUploadState()){
		case US_CONNECTING:
		case US_WAITCALLBACK:
			if (theApp.uploadqueue->IsDownloading(this)){
				SetUploadState(US_UPLOADING);
				Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
				theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
#ifdef OLD_SOCKETS_ENABLED
				socket->SendPacket(packet,true);
#endif //OLD_SOCKETS_ENABLED
			}
	}
	if (m_bFileListRequested){
		Packet* packet = new Packet(OP_ASKSHAREDFILES,0);
		theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
#ifdef OLD_SOCKETS_ENABLED
		socket->SendPacket(packet,true,true);
#endif //OLD_SOCKETS_ENABLED
	}
	EMULE_CATCH
}

int CUpDownClient::GetHashType()
{
	if (m_achUserHash[5] == 13 && m_achUserHash[14] == 110)
		return SO_OLDEMULE;
	else if (m_achUserHash[5] == 14 && m_achUserHash[14] == 111)
		return SO_EMULE;
 	else if (m_achUserHash[5] == 'M' && m_achUserHash[14] == 'L')
		return SO_MLDONKEY;
	else
		return SO_UNKNOWN;
}

void CUpDownClient::ReGetClientSoft()
{
	EMULE_TRY

	// If this client hasnt been contacted, its is SO_UNKNOWN
	if (m_pszUsername.IsEmpty()) {m_clientSoft=SO_UNKNOWN;return;}

	// What is this clients hash type
	int iHashType = GetHashType();
	switch (iHashType) 
	{
		case SO_OLDEMULE: // If the client is an old emule
			m_clientSoft= SO_OLDEMULE;
			break;
		case SO_MLDONKEY: // If the client is an Ml donkey
			m_clientSoft= SO_MLDONKEY;
			break;
		case SO_EMULE:  // If the client is an Emule compatable client
			if( m_byEmuleVersion!=0x99 )
			{
				CString temp;
				temp.Format( "%02X", m_byEmuleVersion );
				m_nClientVersion = _tstoi(temp.GetBuffer())*10;
			}
			switch(m_byCompatableClient) 
			{
				case 0:
					m_clientSoft = SO_EMULE;
					break;
				case 1:
					m_clientSoft = SO_CDONKEY;
					break;
				case 2:
					m_clientSoft = SO_LMULE;
					break;
				case 4:
					m_clientSoft = SO_SHAREAZA;
					break;
				default:
					if (m_bIsML)
						m_clientSoft = SO_MLDONKEY;
					else if (m_bIsHybrid)
						m_clientSoft = SO_EDONKEYHYBRID;
					else
					{
						m_clientSoft = SO_EMULE;
						AddDebugLogLine(false,"New Compatable ClientSoft ET_COMPATABLECLIENT = %i client will be listed as an emule ",m_byCompatableClient);
					}
			}// end: switch m_byCompatableClient 
			break;
		default:
			// If the client is an Ml donkey
			if (m_bIsML) 
				m_clientSoft= SO_MLDONKEY;
			// Were left with donkeys and Hybrids
			if( m_bIsHybrid )
				m_clientSoft=SO_EDONKEYHYBRID;
			else
				m_clientSoft=SO_EDONKEY;
	}

	EMULE_CATCH
}
void CUpDownClient::RequestSharedFileList(){
	EMULE_TRY
	AddDebugLogLine(true,IDS_SHAREDFILES_REQUEST,GetUserName());
	m_bFileListRequested = true;
	TryToConnect(true);
	EMULE_CATCH
}

void CUpDownClient::ProcessSharedFileList(char* pachPacket, uint32 nSize){
	EMULE_TRY
	if (m_bFileListRequested){
		m_bFileListRequested = false;
		theApp.searchlist->ProcessSearchanswer(pachPacket,nSize,this);
	}
	EMULE_CATCH
}

CString CUpDownClient::GetUploadFileInfo()
{
	if(this == NULL) return _T("");
	CString sRet;

	// build info text and display it
	sRet.Format(GetResString(IDS_USERINFO), GetUserName(), GetUserID());
	CKnownFile* file = theApp.sharedfiles->GetFileByID(this->reqfileid);
	if (file)
	{
		sRet += GetResString(IDS_SF_REQUESTED) + CString(file->GetFileName()) + _T("\n");
		CString stat;
		stat.Format(GetResString(IDS_FILESTATS_SESSION)+GetResString(IDS_FILESTATS_TOTAL),
					file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransfered()),
					file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransfered()));
		sRet += stat;
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;

	return _T("");
}

void CUpDownClient::SetUserHash(uchar* m_achTempUserHash){
	if( m_achTempUserHash == NULL ){
		md4clr(m_achUserHash);
		return;
	}
	md4cpy(m_achUserHash,m_achTempUserHash);
}

//BEGIN Improved Tooltips
CString CUpDownClient::GetUploadFileInfo4Tooltips()
{
	EMULE_TRY
	if(this == NULL) return _T("");
	CString sRet;

	// build info text and display it
	sRet.Format(GetResString(IDS_TT_USERINFO), GetUserName(), GetUserID());
	CKnownFile* file = theApp.sharedfiles->GetFileByID(this->reqfileid);
	if (file)
	{
		CString sFileName;
		sFileName.Format(GetResString(IDS_TT_REQUESTED), CString(file->GetFileName()));

		CString stat;
		stat.Format(sFileName+GetResString(IDS_TT_FILESTATS_SESSION)+GetResString(IDS_TT_FILESTATS_TOTAL),
					file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransfered()),
					file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransfered()));
		sRet += stat;
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;

	EMULE_CATCH

	return _T("");
}
//END Improved Tooltips
