//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "stdafx.h"
#include "knownfile.h"
#include "types.h"
#include "opcodes.h"
#include "BarShader.h"
#include "sourcesaver.h" //<<-- enkeyDEV(Ottavio84) -New SLS-

#define PS_READY			0
#define PS_EMPTY			1
#define PS_WAITINGFORHASH	2
#define PS_HASHING			3
#define PS_ERROR			4
#define PS_UNKNOWN			6
#define PS_PAUSED			7
#define PS_COMPLETING		8
#define PS_COMPLETE			9
#define PS_STOPPED			10	//eklmn: added stop status

// #define BUFFER_SIZE_LIMIT	500000 // Max bytes before forcing a flush
#define BUFFER_TIME_LIMIT	180000   // Max milliseconds before forcing a flush // netwolf: increased to 3 minutes (be nice to your HDD :))

//--- xrmb:partprio ---
//--- moved to opcodes ---
/*
#define PR_VERYLOW			4 // I Had to change this because it didn't save negative number correctly.. Had to modify the sort function for this change..
#define PR_LOW				0 //*
#define PR_NORMAL			1 // Don't change this - needed for edonkey clients and server!
#define	PR_HIGH				2 //*
#define PR_VERYHIGH			3
#define PR_AUTO				5 // Added by Tarod
*/
//--- :xrmb ---

class CSearchFile;
class CUpDownClient;
class CClientSource;

struct PartFileBufferedData
{
	BYTE	*data;						// Barry - This is the data to be written
	uint32	start;						// Barry - This is the start offset of the data
	uint32	end;						// Barry - This is the end offset of the data
	Requested_Block_Struct *block;		// Barry - This is the requested block that this data relates to
};

class CPartFile : public CKnownFile {
public:
	CPartFile();
	CPartFile(CSearchFile* searchresult);  //used when downloading a new file
	CPartFile(CString edonkeylink);
	CPartFile(class CED2KFileLink* fileLink);
	void	InitializeFromLink(CED2KFileLink* fileLink);
	virtual	~CPartFile();
	
	bool	CreateFromFile(char* directory,char* filename)	{return false;}// not supported in this class
	bool	LoadFromFile(FILE* file)						{return false;}
	bool	WriteToFile(FILE* file)							{return false;}
	bool	IsPartFile()									{return !(status == PS_COMPLETE);}
	bool	FirstLastLoaded();	//Cax2 - needed to disable the menu item
	uint32	Process(uint32 reducedownload, uint32 iteration);
	bool	LoadPartFile(LPCTSTR in_directory, LPCTSTR filename); //filename = *.part.met
	bool	SavePartFile();
	void	PartFileHashFinished(CKnownFile* result);
	bool	HashSinglePart(uint16 partnumber); // true = ok , false = corrupted	
	
	void	AddGap(uint32 start, uint32 end);
	void	FillGap(uint32 start, uint32 end);
	void	DrawStatusBar(CDC* dc, RECT* rect, bool bFlat);
	bool	IsComplete(uint32 start, uint32 end);
	bool	IsPureGap(uint32 start, uint32 end);
	bool	IsCorruptedPart(uint16 partnumber);
	void	UpdateCompletedInfos();
	void	GetGapsInPart(CUpDownClient* sender, uint16 numPart, Requested_Block_Struct** newblocks, uint16* count); //jicxicmic
	uint16	GetNextRequestedBlock(CUpDownClient* sender);	//jicxicmic
	void	WritePartStatus(CFile* file);
	bool	HasParts(); // DbT:StartUploadReq
	void	WriteCompleteSourcesCount(CFile* file);	// netwolf: complete sources (zegzav) 13.05.03
	void	AddSources(CMemFile& sources,uint32 serverip, uint16 serverport);
	uint8	GetStatus(bool ignorepause = false);
	void		NewSrcPartsInfo();
	void		SetPriority(uint8 np);
	CString	GetPartMetFileName() const						{return partmetfilename;}
	uint32	GetTransfered()									{return transfered;}
	uint8	GetPriority()									{return priority;}
	CString	GetFullName() const								{return fullname;}
	CString	GetTempDir() const								{return tempdir;}	// added by InterCeptor (multiple tempdirs) 19.11.02
	uint16	GetSourceCount();
	uint16	GetTransferingSrcCount()						{return transferingsrc;}
	uint32	GetDatarate()									{return datarate;}
	float	GetPercentCompleted()							{return percentcompleted;}
	uint16  GetNotCurrentSourcesCount();
	int		GetValidSourcesCount();
	uint16	GetCompleteSourcesCount();									// netwolf: complete sources (zegzav) 03.05.03
	uint8	GetCompleteSourcesAccuracy()					{return 0;}	// netwolf: complete sources (zegzav) 03.05.03
	bool	IsMovie();
	bool 	IsAviMovie(); 										//Vorlost for LoadRarestFinishedChunks Patch2
	bool 	IsMpgMovie(); 										//Vorlost for LoadRarestFinishedChunks Patch2
	bool 	IsMovieChunk(uint8 mode,uint16 chunk); 				//Vorlost for LoadRarestFinishedChunks Patch2
	bool 	IsBetterMovieChunk(uint16 oldchunk,uint16 newchunk);//Vorlost for LoadRarestFinishedChunks Patch2
	bool 	Movie1(uint8 mode,uint16 oldchunk,uint16 newchunk); //Vorlost for LoadRarestFinishedChunks Patch2
	bool 	Movie2(uint8 mode,uint8 raremovie,bool forcepreview,uint16 oldchunk,uint16 newchunk); //Vorlost for LoadRarestFinishedChunks Patch2
	uint8 	PrepareComparePart(uint16 chunk); 					//Vorlost for LoadRarestFinishedChunks Patch2
	bool	IsArchive();										// Barry - Also want to preview archives
	CString GetPartfileStatus();
	sint32	GetTimeRemaining(bool bAvgerage = false);
	CTime	lastseencomplete;
	int		getPartfileStatusRang();
	//bond006 (smoothed "remaining time" calculation) //SyruS
	void	SetStartTimeReset(bool bEnable)					{m_StartTimeReset = bEnable;}
	bool	GetStartTimeReset()								{return m_StartTimeReset;}
	uint32	GetAvgDatarate(bool bUpdated = false);
	uint32	GetSessionTransfered()	{return (completedsize > m_SessionStartSize ? completedsize - m_SessionStartSize : 0);}
	CTimeSpan GetFlushTimeSpan()	{return (m_LastDownTransfer - m_SessionStartTime);}
	CTimeSpan GetSessionTimeSpan()	{return (CTime::GetCurrentTime() - m_SessionStartTime);}

	// Barry - Added as replacement for BlockReceived to buffer data before writing to disk
	uint32	WriteToBuffer(uint32 transize, BYTE *data, uint32 start, uint32 end, Requested_Block_Struct *block);
	void	FlushBuffer(void);
	// Barry - This will invert the gap list, up to caller to delete gaps when done
	// 'Gaps' returned are really the filled areas, and guaranteed to be in order
	void	GetFilledList(CTypedPtrList<CPtrList, Gap_Struct*> *filled);
	// Barry - Is archive recovery in progress
	volatile bool m_bRecoveringArchive;
	// Barry - Added to prevent list containing deleted blocks on shutdown
	void	RemoveAllRequestedBlocks(void);
	
	uint16  CPartFile::GetRemainingBlocksInPart(uint16 partnumber); //By Vorlost for load rarest chunks first
	void	RemoveBlockFromList(uint32 start,uint32 end);
	void	RemoveAllSources(bool bTryToSwap);
	void	DeleteFile();
	void	StopFile();
	bool	IsPaused()						{return paused;}
	void	PauseFile();
	void	ResumeFile();
	void	GetSourcesAfterServerConnect(); // Added by Vorlost to load initial sources from Server after connect

	virtual	Packet* CreateSrcInfoPacket(CUpDownClient* ForClient);
	//v1:- eklmn: support Source Exchange v2
	void	AddClientSources(CMemFile* sources, uint8 sourceexchangeversion = 1);

	void	PreviewFile();
	bool	PreviewAvailable();
	bool	IsVLCInstalled(); // DonGato
	uint8   GetAvailablePartCount()			{return availablePartsCount;}
	//void	UpdateAvailablePartsCount();

	uint32	GetLastAnsweredTime()			{ return m_ClientSrcAnswered; }
	void	SetLastAnsweredTime()			{ m_ClientSrcAnswered = ::GetTickCount(); }
	void	SetLastAnsweredTimeTimeout()	{ m_ClientSrcAnswered = 2 * CONNECTION_LATENCY + ::GetTickCount() - SOURCECLIENTREASK; }
	uint64	GetLostDueToCorruption()		{return m_iLostDueToCorruption;}
	uint64	GetGainDueToCompression()		{return m_iGainDueToCompression;}
	uint32	TotalPacketsSavedDueToICH()		{return m_iTotalPacketsSavedDueToICH;}
	bool	HasComment()					{return hasComment;}
	bool	HasRating()						{return hasRating;}
	int		GetRating();
	void	SetHasComment(bool in)			{hasComment=in;}
	void	SetHasRating(bool in)			{hasRating=in;}
	void	UpdateFileRatingCommentAvail();

	int		GetCommonFilePenalty();
	void	UpdateDisplayedInfo(boolean force=false);

	void	GetSizeToTransferAndNeededSpace(uint32& pui32SizeToTransfer, uint32& pui32NeededSpace);	// added by InterCeptor (xChipx: download statistics) 11.11.02

	CFile	m_hpartfile;	//permanent opened handle to avoid write conflicts
	volatile bool m_bPreviewing;

	//--- xrmb:sacrifice ---
	uint16	GetSrcpartFrequency(uint16 part) { return m_SrcpartFrequency[part]; }
	//--- :xrmb ---

	// Added by Tarod
	void    UpdateDownloadAutoPriority(void);		// Added by Tarod for DAP
	bool	IsAutoPrioritized() 					{ return m_bAutoPriority ; }
	void	SetAutoPriority(bool newAutoPriority) 	{ m_bAutoPriority = newAutoPriority ; }
	void	RemoveNoNeededSources(uint32 number_sources_to_remove = 0xffffffff);
	// End Tarod

    // now used for other settings too, probably needs renaming [obaldin]
	void   	LoadMovieMode(); // DonGato 
	void   	SaveMovieMode(); // DonGato

    // per-file control whether to drop supercompressed blocks [obaldin]
private:
    bool	m_bDiscardSuperCompressed;
public:
    bool	GetDiscardSuperCompressed() {return m_bDiscardSuperCompressed;};
    void	SetDiscardSuperCompressed(bool discard_sc) {m_bDiscardSuperCompressed = discard_sc;};

	//SyruS moved from protected to public cause bugfix in CUpDownClient::CreateNextBlockPackage()
	CMutex 	m_FileCompleteMutex; // Lord KiRon - Mutex for file completion
	
protected:
	bool	GetNextEmptyBlockInPart(uint16 partnumber,Requested_Block_Struct* result);
	bool	IsAlreadyRequested(uint32 start, uint32 end);
	void	CompleteFile(bool hashingdone);
	void	CreatePartFile();
	void	Init();
	CSourceSaver m_sourcesaver; //<<-- enkeyDEV(Ottavio84) -New SLS-
	
private:
	static	CMutex s_ComplitingMutex;
	uint16	count;
	uint16	transferingsrc;
	uint32  completedsize;
	uint64	m_iLostDueToCorruption;
	uint64	m_iGainDueToCompression;
	uint32  m_iTotalPacketsSavedDueToICH; 
	uint32	datarate;
	CString	fullname;
	CString	tempdir;	// InterCeptor (multiple tempdirs)
	CString	partmetfilename;
	uint32	transfered;
	bool	paused;
	uint8	priority;
	uint8	status;
	bool	newdate;	// indicates if there was a writeaccess to the .part file
	uint32	lastsearchtime;
	uint32	lastpurgetime;
	uint32	m_LastNoNeededCheck;
	CTypedPtrList<CPtrList, Gap_Struct*> gaplist;
	CTypedPtrList<CPtrList, Requested_Block_Struct*> requestedblocks_list;
	CArray<uint16,uint16> m_SrcpartFrequency;
	//  v- eklmn: feature(00): ICR
	uint16  median;
	uint16	m_MaxSrcPartFrequency;
	CArray<uint32,uint32> m_ReqParts;
	CArray<CUpDownClient*, CUpDownClient*> m_BlockedParts;
	//  ^- eklmn: feature(00): ICR
	// eklmn: download optimization
	CTypedPtrList<CPtrList, CUpDownClient*> m_downloadingSourceList;
	float	percentcompleted;
	CList<uint16,uint16>	corrupted_list;
	uint8	availablePartsCount;
	uint32	m_ClientSrcAnswered;
	uint32	m_nSavedReduceDownload;
	bool	m_bPercentUpdated;
	static	CBarShader s_LoadBar; 
	static	CBarShader s_ChunkBar;
	// Tarod 
	bool	m_bAutoPriority;
	DWORD	m_LastRemovedTime;	//unused!

	CString DtLocale(CTime dt);
	//bond006 (smoothed "remaining time" calculation) //SyruS
	CTime	m_SessionStartTime;
	uint32	m_SessionStartSize;
	uint32	m_AvgDataRate;
	bool	m_StartTimeReset;
	//--- xrmb:confirmeddownload ---
	float	percentconfirmed;
	uint32  confirmedsize;
	//--- :xrmb ---

	bool	hasRating;
	bool	hasComment;
	BOOL 	PerformFileComplete(); // Lord KiRon
	static UINT CompleteThreadProc(CPartFile* pFile); // Lord KiRon - Used as separate thread to complete file
	DWORD	m_lastRefreshedDLDisplay;

	// Barry - Buffered data to be written
	CTypedPtrList<CPtrList, PartFileBufferedData*> m_BufferedData_list;
	uint32 m_nTotalBufferData;
	uint32 m_nLastBufferFlushTime;
	uint16	m_nLastCompleteSrcCount;	// netwolf: complete sources (zegzav) 13.05.03
	bool	m_bUpdateCompleteSrcCount;

	//--- xrmb:keepPartFileStats ---
	CString GetStatsFullPath() const;
	bool	LoadPartFileStats();
	int		RemovePartFileStats();
	//--- :xrmb ---

public:
	//--- xrmb:keepPartFileStats ---
	bool	SavePartFileStats();	// its called from the downloadqueue/process
	//--- :xrmb ---


	CTypedPtrList<CPtrList, CUpDownClient*> srclists[SOURCESSLOTS];
	// v1:- eklmn: A4AF management
	CTypedPtrList<CPtrList, CUpDownClient*> A4AF_srclist;

	bool	srcarevisible; // used for downloadlistctrl
	bool	hashsetneeded;							
	uint32  GetCompletedSize()   {return completedsize;}

private:
    CTime   m_LastDownTransfer;   // obaldin
	CString m_alternativepath;	//<<-- enkeyDEV(Ottavio84) -ChangeDir-	
public:
	CTime   GetLastDownTransfer() {return m_LastDownTransfer;};// obaldin
	void AddClientSources(CTypedPtrList<CPtrList, CClientSource*>*);
	//v1:- eklmn: support Source Exchange v2
	void AddClientSource(CClientSource* source, int i_Source=0, bool exchanged=false, uint8 sourceexchangeversion = 0);
	void AddClientHostnameSources(CTypedPtrList<CPtrList, CClientSource*>);
	CString CreateED2KSourceLink(uint32 expirein, int sourcenum); //<<-- enkeyDEV(Ottavio84) -Create source ed2k from downloads-
	// START - enkeyDEV(Ottavio84) -ChangeDir-
	void	SetAlternativeOutputDir(CString* path);
	CString GetOutputDir();
	// END - enkeyDEV(Ottavio84 - -ChangeDir-

	// Locale completed and downtimes
	CString localelastseencomplete()	{return DtLocale(lastseencomplete);}
	CString localelastdowntransfer()	{return DtLocale(m_LastDownTransfer);}

	CString GetProgressString(uint16 size);
	void CharFillRange(CString* buffer,float start, float end, char color);
	CString	GetDownloadFileInfo();
	CString	GetDownloadFileInfo4Tooltips();
	void 	DownloadAllA4AF();
	void	AddDownloadingSource(CUpDownClient* client);
	void	RemoveDownloadingSource(CUpDownClient* client);
	uint32 	GetBytesInPart(uint16 partnumber, bool left2DL = false, bool dontRecalculate = false);	//eklmn: feature(00): ICR 2.10
};
