// PreferencesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PreferencesDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPreferencesDlg

IMPLEMENT_DYNAMIC(CPreferencesDlg, CPropertySheet)
CPreferencesDlg::CPreferencesDlg(){
	m_visible = false;
	m_psh.dwFlags &= ~PSH_HASHELP;
	m_wndGeneral.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndConnection.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndProxy.m_psp.dwFlags &= ~PSP_HASHELP;   // Maverick
	m_wndServer.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndAdvanced.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndDirectories.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndFiles.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndIRC.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndHTTPD.m_psp.dwFlags &= ~PSP_HASHELP;  	// LENN HT
	m_wndStats.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndMessaging.m_psp.dwFlags &= ~PSH_HASHELP;
	m_wndNotify.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndModPT.m_psp.dwFlags &= ~PSP_HASHELP;
	m_wndScheduler.m_psp.dwFlags &= ~PSH_HASHELP; // DonGato
	m_wndSorting.m_psp.dwFlags &= ~PSP_HASHELP; // Cax2
	m_wndWindow.m_psp.dwFlags &= ~PSP_HASHELP;	// DonGato
	
	AddPage(&m_wndGeneral);
	AddPage(&m_wndConnection);
	AddPage(&m_wndProxy);       // Maverick
	AddPage(&m_wndServer);
	AddPage(&m_wndAdvanced);
	AddPage(&m_wndDirectories);
	AddPage(&m_wndFiles);
	AddPage(&m_wndIRC);
	AddPage(&m_wndHTTPD);  		// LENN HT
	AddPage(&m_wndStats);
	AddPage(&m_wndNotify);
	AddPage(&m_wndMessaging); //<<-- enkeyDEV(kei-kun) -Messaging preferences-
	AddPage(&m_wndModPT);
	AddPage(&m_wndScheduler);	// DonGato
	AddPage(&m_wndSorting);		// Cax2
	AddPage(&m_wndWindow);		// DonGato

	m_nActiveWnd = 0;

	ImageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_GENERAL),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_CONNECTION),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_PROXY),16,16)); // Maverick
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SERVER),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_ADVANCED),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_FOLDERS),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_FILES),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_IRC),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_WEBSERVER),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_STATISTICS),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_NOTIFICATIONS),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_MPENDING),16,16)); //<<-- enkeyDEV(kei-kun) -Messaging preferences-
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_MODPT),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SCHEDULER),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SORTING),16,16));
	ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_WINDOW),16,16));
	LoadImgLstIcon(NULL,0,0);	// delete temp-icon
}

CPreferencesDlg::~CPreferencesDlg()
{
	ImageList.Detach();
}

INT_PTR CPreferencesDlg::DoModal()
{
	if(!m_visible){
		m_visible = true;
		return CPropertySheet::DoModal();
	}
	else
		return FALSE;
}

BEGIN_MESSAGE_MAP(CPreferencesDlg, CPropertySheet)
	ON_WM_DESTROY()
	ON_LBN_SELCHANGE(111,OnSelChanged)
	ON_COMMAND(ID_APPLY_NOW, OnApplyNow)
	ON_COMMAND(IDOK, OnOk)
END_MESSAGE_MAP()

void CPreferencesDlg::OnDestroy()
{
	m_visible = false;
	CPropertySheet::OnDestroy();
//	app_prefs->Save();
	m_nActiveWnd = GetActiveIndex();
}

void CPreferencesDlg::OnApplyNow()
{
	Default();

	app_prefs->Save();
}

void CPreferencesDlg::OnOk()
{
	Default();

	app_prefs->Save();
}

BOOL CPreferencesDlg::OnInitDialog()
{		
	EnableStackedTabs(FALSE);
	BOOL bResult = CPropertySheet::OnInitDialog();

	m_listbox.CreateEx(WS_EX_CLIENTEDGE,_T("Listbox"),0,WS_CHILD|WS_VISIBLE|LBS_NOTIFY|WS_TABSTOP|LBS_HASSTRINGS|LBS_OWNERDRAWVARIABLE|WS_BORDER,CRect(0,0,0,0),this,111);
	::SendMessage(m_listbox.m_hWnd, WM_SETFONT, (WPARAM) ::GetStockObject(DEFAULT_GUI_FONT),0);

	m_listbox.SetImageList(&ImageList);
	SetActivePage(m_nActiveWnd);
	Localize();	
	m_listbox.SetFocus();
	return bResult;
}

void CPreferencesDlg::OnSelChanged()
{
	int curSel=m_listbox.GetCurSel();
	SetActivePage(curSel);
	CString currenttext;
	m_listbox.GetText(curSel,currenttext);
	CString title = GetResString(IDS_EM_PREFS);
	title.Remove('&');
	SetWindowText(title+_T(": ")+currenttext);
	// SetIcon(ImageList.ExtractIcon(curSel),FALSE);
	m_listbox.SetFocus();
}

void CPreferencesDlg::Localize()
{
	m_wndGeneral.Localize();
	m_wndConnection.Localize();
	m_wndProxy.Localize();    // Maverick
	m_wndServer.Localize();
	m_wndAdvanced.Localize();
	m_wndDirectories.Localize();
	m_wndFiles.Localize();
	m_wndIRC.Localize();
	m_wndHTTPD.Localize();
	m_wndStats.Localize();
	m_wndNotify.Localize();
	m_wndMessaging.Localize(); //<<-- enkeyDEV(kei-kun) -Messaging preferences-
	m_wndModPT.Localize();
	m_wndScheduler.Localize();
	m_wndSorting.Localize();
	m_wndWindow.Localize();

	CStringArray buffer; 
	buffer.Add(GetResString(IDS_PW_GENERAL)); 
	buffer.Add(GetResString(IDS_PW_CONNECTION)); 
	buffer.Add(GetResString(IDS_PW_PROXY));  // Maverick
	buffer.Add(GetResString(IDS_PW_SERVER)); 
	buffer.Add(GetResString(IDS_PW_ADVANCED));
	buffer.Add(GetResString(IDS_PW_DIR)); 
	buffer.Add(GetResString(IDS_PW_FILES)); 
	buffer.Add(GetResString(IDS_IRC)); 
	buffer.Add(GetResString(IDS_PW_HTTPD));
	buffer.Add(GetResString(IDS_STATSSETUPINFO)); 
	buffer.Add(GetResString(IDS_PW_EKDEV_OPTIONS));
	buffer.Add(GetResString(IDS_PW_IM_OPTIONS));  //<<-- enkeyDEV(kei-kun) -Messaging preferences-
	buffer.Add(GetResString(IDS_PW_MODPT));
	buffer.Add(GetResString(IDS_PW_SCHEDULER));
	buffer.Add(GetResString(IDS_PW_SORTING));
	buffer.Add(GetResString(IDS_PW_WINDOW));

	m_listbox.ResetContent();
	int width = 0;
	CClientDC dc(this);
	CFont * f = m_listbox.GetFont();
	CFont * pOldFont=dc.SelectObject(f);
	CSize sz;
	for(int i = 0; i < GetPageCount(); i++) 
	{ 
		m_listbox.AddString(buffer[i],i);
		sz = dc.GetTextExtent(buffer[i]);
		if(sz.cx > width)
			width = sz.cx;
	}
	dc.SelectObject(pOldFont);
	width+=50;
	CRect rectOld;
	m_listbox.GetWindowRect(&rectOld);
	int xoffset, yoffset;
	if(IsWindowVisible())
	{
		yoffset=0;
		xoffset=width-rectOld.Width();
	}
	else
	{
		xoffset=width-rectOld.Width()+10;
		GetActivePage()->GetWindowRect(rectOld);
		ScreenToClient (rectOld);
		yoffset=-rectOld.top;
	}
	GetWindowRect(rectOld);
	SetWindowPos(NULL,0,0,rectOld.Width()+xoffset,rectOld.Height()+yoffset,SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);
	CTabCtrl* tab = GetTabControl();
	tab->GetWindowRect (rectOld);
	ScreenToClient (rectOld);
	tab->SetWindowPos(NULL,rectOld.left+xoffset,rectOld.top+yoffset,0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
	CPropertyPage* activepage = GetActivePage();
	activepage->GetWindowRect(rectOld);
	ScreenToClient (rectOld);
	activepage->SetWindowPos(NULL,rectOld.left+xoffset,rectOld.top+yoffset,0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
	GetClientRect(rectOld);
	m_listbox.SetWindowPos(NULL,6,6,width,rectOld.Height()-12,SWP_NOZORDER|SWP_NOACTIVATE);
	int _PropSheetButtons[] = {IDOK, IDCANCEL, ID_APPLY_NOW, IDHELP };
	CWnd* PropSheetButton;
	for (int i = 0; i < sizeof (_PropSheetButtons) / sizeof(_PropSheetButtons[0]); i++)
	{
		if (PropSheetButton=GetDlgItem(_PropSheetButtons[i]))
		{
			PropSheetButton->GetWindowRect (rectOld);
			ScreenToClient (rectOld);
			PropSheetButton->SetWindowPos (NULL, rectOld.left+xoffset,rectOld.top+yoffset,0,0,SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
		}
	}
	tab->ShowWindow(SW_HIDE);
	m_listbox.SetCurSel(GetActiveIndex());		
	OnSelChanged();
	CenterWindow();
	Invalidate();
	RedrawWindow();
}
