//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// TransferWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "TransferWnd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CTransferWnd dialog

IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)
CTransferWnd::CTransferWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CTransferWnd::IDD, pParent)
{
}

CTransferWnd::~CTransferWnd()
{
	SafeRollupItemHeights();
}

BEGIN_MESSAGE_MAP(CTransferWnd, CResizableDialog)
	//BEGIN Improved Tooltips
	//ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT,0,0xFFFF,OnToolTipNotify)
	ON_NOTIFY_EX_RANGE(UDM_TOOLTIP_DISPLAY,0,0xFFFF,OnToolTipNotify)
	//END Improved Tooltips
	ON_WM_DESTROY()	// eklmn: bugfix(00): resource cleanup due to CResizableDialog
END_MESSAGE_MAP()


BOOL CTransferWnd::OnInitDialog()
{
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	m_bFirstShow=true;
	Localize();

	CRect rRollupArea;
	GetClientRect(&rRollupArea);
	rRollupArea.DeflateRect(11,11); // (7,7)

	rollupctrl.Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, rRollupArea, this, 123);
	
	CRect rItem = rRollupArea;
	rItem.top += 22;
	rItem.bottom = rItem.top + (rRollupArea.Height() - 3 * 22) / 2;
	downloadlistctrl.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | 
							LVS_NOLABELWRAP | LVS_OWNERDRAWFIXED | LVS_SINGLESEL, rItem, &rollupctrl, IDC_DOWNLOADLIST);
	downloadlistctrl.Init();
	downloadlistctrl.SetOwner(this);
		
	rItem.top = rItem.bottom + 22;
	rItem.bottom = rItem.top + (rRollupArea.Height() - 3 * 22) / 4;
	uploadlistctrl.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | LVS_SINGLESEL | LVS_OWNERDRAWFIXED,
							rItem, &rollupctrl, IDC_UPLOADLIST);
	uploadlistctrl.Init();
	uploadlistctrl.SetOwner(this);

	queuelistctrl.Create(/*WS_VISIBLE |*/ WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | LVS_SINGLESEL | LVS_OWNERDRAWFIXED,
							rItem, &rollupctrl, IDC_QUEUELIST);
	queuelistctrl.Init();
	queuelistctrl.SetOwner(this);

    m_nActiveWnd = 0;

	rItem.top = rItem.bottom + 22;
	rItem.bottom = rItem.top + (rRollupArea.Height() - 3 * 22) / 4;
	infolistctrl.Create(WS_VISIBLE | WS_CHILD | WS_BORDER | WS_TABSTOP | LVS_REPORT | LVS_ALIGNLEFT | LVS_SINGLESEL,
							rItem, &rollupctrl, 127);

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_DOWNINFO), theApp.downloadqueue->GetFileCount(),
						theApp.downloadqueue->GetTransferingFiles(),
							(float)theApp.downloadqueue->GetDatarate() / 1024);
	rollupctrl.InsertItem(GetResString(IDS_RUP_DOWNLOADS), strBuffer, &downloadlistctrl, 0, TRUE);


	strBuffer.Format(GetResString(IDS_RUP_UPINFO), theApp.uploadqueue->GetWaitingUserCount(),
						theApp.uploadqueue->GetUploadQueueLength(), 
							theApp.uploadqueue->GetBanCount(),
								(float)theApp.uploadqueue->GetDatarate()/1024);
	rollupctrl.InsertItem(GetResString(IDS_RUP_UPLOADS), strBuffer, &uploadlistctrl, 1, TRUE);
		
	rollupctrl.InsertItem(GetResString(IDS_RUP_INFO), _T(""), &infolistctrl, 2, FALSE);
//	rollupctrl.SetHeaderColor(2, 0, GetSysColor(COLOR_3DSHADOW));

	AddAnchor(rollupctrl.m_hWnd, TOP_LEFT, BOTTOM_RIGHT);
	InitRollupItemHeights();

	// create tooltip
	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 20000);
	m_ttip.SetDelayTime(TTDT_INITIAL, theApp.glob_prefs->GetToolTipDelay()*1000+25);	//netwolf: avoid jitter when delay is set to 0
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!

	//BEGIN Improved Tooltips
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW);
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&downloadlistctrl, _T(""));	
	m_ttip.AddTool(&uploadlistctrl, _T(""));
//	m_ttip.SetFont(_T("Courier"), 9);
	//END Improved Tooltips

	m_iOldToolTipItemDown = -1;
	m_iOldToolTipItemUp = -1;
	m_iOldToolTipItemQueue = -1;
	
	downloadlistctrl.SetOwner(this);
	uploadlistctrl.SetOwner(this);
	queuelistctrl.SetOwner(this);

	EMULE_CATCH

	return true;
}

// v- eklmn: bugfix(00): resource cleanup due to CResizableDialog
void CTransferWnd::OnDestroy()
{
	CResizableDialog::OnDestroy();
}

// ^- eklmn: bugfix(00): resource cleanup due to CResizableDialog

void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
}

// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	// eklmn: bugfix(07): Update tooltip only in case corresponding WM_MESSAGE
	if (pMsg->message == WM_LBUTTONDOWN || pMsg->message== WM_LBUTTONUP 
		|| pMsg->message == WM_RBUTTONDOWN || pMsg->message== WM_RBUTTONUP 
		|| pMsg->message== WM_MOUSEMOVE
		|| pMsg->message== WM_KEYDOWN || pMsg->message==WM_SYSKEYDOWN )
	{
		m_ttip.RelayEvent(pMsg);
	}

	// handle tooltip updating, when mouse is moved from one item to another
	if (pMsg->message == WM_MOUSEMOVE)
		UpdateToolTips();


	if(pMsg->message == USRMSG_SWITCHUPLOADLIST)
		SwitchUploadList();

	return CResizableDialog::PreTranslateMessage(pMsg);
}

void CTransferWnd::UpdateToolTips(void)
{	
	EMULE_TRY

	int sel = GetItemUnderMouse((CListCtrl*)rollupctrl.GetItemClient(0));	// this is a quick fix,
	if (sel != -1)															// we should find a better solution
	{
		if (sel != m_iOldToolTipItemDown)
		{
			if(m_ttip.IsWindowVisible())
				//BEGIN Improved Tooltips
				//m_ttip.Update();
				m_ttip.UpdateData();
				//END Improved Tooltips
			m_iOldToolTipItemDown = sel;
			return;
		}
	}
	int sel2 = GetItemUnderMouse((CListCtrl*)rollupctrl.GetItemClient(1));	// see above
	if (sel2 != -1)
	{
		if (sel2 != m_iOldToolTipItemUp)
		{
			if (m_ttip.IsWindowVisible())
				//BEGIN Improved Tooltips
				//m_ttip.Update();
				m_ttip.UpdateData();
				//END Improved Tooltips
			m_iOldToolTipItemUp = sel2;
			return;
		}
	}
/* no tooltips needed ATM
	int sel3 = GetItemUnderMouse(&queuelistctrl);
	if (sel3 != -1)
	{
		if (sel3 != m_iOldToolTipItemQueue)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemQueue = sel3;
		}
	}
*/
	if (sel == -1 && sel2 == -1 /*&& sel3 != -1*/)
		m_ttip.Pop();

	EMULE_CATCH
}

int CTransferWnd::GetItemUnderMouse(CListCtrl* ctrl)
{
	EMULE_TRY

	CPoint pt;
	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);
	LVHITTESTINFO hit, subhit;
	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);
	int sel = ctrl->HitTest(&hit);
	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
	{
		if (subhit.iSubItem == 0)
			return sel;
	}

	EMULE_CATCH

	return LB_ERR;
}

BOOL CTransferWnd::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult)
{
	EMULE_TRY

	//BEGIN Improved Tooltips
	//TOOLTIPTEXT *pText = (TOOLTIPTEXT *)pNMH;
	//int control_id = ::GetDlgCtrlID((HWND)pNMH->idFrom);
	NM_PPTOOLTIP_DISPLAY * pNotify = (NM_PPTOOLTIP_DISPLAY*)pNMH;
	int control_id = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();
	//END Improved Tooltips

	if (!control_id)
		return FALSE;
	CString info;
	if (control_id == IDC_DOWNLOADLIST)
	{
		if (downloadlistctrl.GetItemCount() < 1)
			return FALSE;
		int sel = GetItemUnderMouse(&downloadlistctrl);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		CMuleCtrlItem* content = (CMuleCtrlItem*)downloadlistctrl.GetItemData(sel);
		if (content->IsFile()) // for downloading files
		{
			CPartFile* partfile = content->GetFile();

			//BEGIN Improved Tooltips
			info = partfile->GetDownloadFileInfo4Tooltips();

			SHFILEINFO shfi;
			memset(&shfi,0,sizeof(shfi));
			SHGetFileInfo(partfile->GetFileName(),
				FILE_ATTRIBUTE_NORMAL, &shfi, sizeof(shfi),
				SHGFI_ICON|SHGFI_USEFILEATTRIBUTES);
			pNotify->ti->hIcon = shfi.hIcon;

			downloadlistctrl.SetFocus();
			//END Improved Tooltips
		}
		else if (content->IsSource()) // for sources
		{
			bool bA4AF = content->IsAskedForAnotherFile();
			CUpDownClient* client = content->GetSource();
			in_addr server;
			server.S_un.S_addr = client->GetServerIP();

			//BEGIN Improved Tooltips
			info.Format(GetResString(IDS_TT_USERINFO)
				+GetResString(IDS_TT_CLIENT)
				+GetResString(IDS_TT_SERVER)
				+GetResString(IDS_TT_SOURCEINFO)
				+GetResString(IDS_TT_SOURCEINFO2),
						client->GetUserName(), client->GetUserID(),
						client->GetFullIP(), client->GetUserPort(), 
						inet_ntoa(server), client->GetServerPort(),
						client->GetAskedCountDown(), client->GetAvailablePartCount());	//eklmn: bugfix(15): show values for download asked
			if (!bA4AF)
			{	// normal client
				CString sClientSrcName;
				sClientSrcName.Format(GetResString(IDS_TT_CLIENTSOURCENAME),
					CString(client->GetClientFilename()));
				info += sClientSrcName;
			}
			else
			{
				//Cax2- get local file name
				try{
					CString sA4AFFileName;
					sA4AFFileName.Format(GetResString(IDS_TT_ASKEDFAF),
						client->reqfile->GetFileName());
					info += sA4AFFileName;
				}catch(...){}
            }
         //-For File Comment-// 
		     try { 
				if (!bA4AF){
					if (client->GetFileComment() != "") { 
						CString sFileComment;
						sFileComment.Format(GetResString(IDS_TT_CMT_READ),
							CString(client->GetFileComment()));
						info += sFileComment; 
					} 
					else { 
						//No comment entered 
						info += GetResString(IDS_TT_CMT_NONE); 
					} 
					if (GetRateString(client->GetFileRate())==GetResString(IDS_CMT_NOTRATED))
						info += GetResString(IDS_TT_CMT_NOTRATED);
					else
					{
						CString sRate;
						sRate.Format(GetResString(IDS_TT_CMT_RATING),
								GetRateString(client->GetFileRate()));
						info += sRate;
					} 
				}
			} catch(...) { 
				//Information not received = not connected or connecting 
				info += GetResString(IDS_TT_CMT_NOTCONNECTED); 
			} 
	         //-End file comment-//

			//set the tooltip icon - Hehe with new icons this time :P
			switch(client->GetClientSoft()) {
				case SO_CDONKEY:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(9);
					break;
				case SO_LMULE:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(10);
					break;
				case SO_SHAREAZA:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(11);
					break;
				case SO_EDONKEYHYBRID:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(3);
					break;
				case SO_MLDONKEY:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(2);
					break;
				case SO_EMULE:
				case SO_OLDEMULE:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(1);
					break;
				case SO_EDONKEY:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(0);
					break;
				default:
					pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(8);
					break;
			}
			//END Improved Tooltips
		}
	}
	else if (control_id == IDC_UPLOADLIST)
	{
		if (uploadlistctrl.GetItemCount() < 1)
			return FALSE;
		int sel = GetItemUnderMouse(&uploadlistctrl);
		if (sel < 0 || sel == 65535)
			return FALSE;

		CUpDownClient* client = (CUpDownClient*)uploadlistctrl.GetItemData(sel);

		//BEGIN Improved Tooltips
		/*
		info = client->GetUploadFileInfo4Tooltips();
	    if(client->GetClientSoft() == SO_EDONKEYHYBRID)
			pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(3);
		else if (client->GetClientSoft() == SO_MLDONKEY)
			pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(2);
		else if (client->GetClientSoft()==SO_EMULE || client->GetClientSoft()==SO_OLDEMULE)
			pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(1);
		else
			pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(0);
		*/

		info = client->GetUploadFileInfo4Tooltips();

		//Display the client icon - with new icons this time :P
		switch(client->GetClientSoft()) {
			case SO_CDONKEY:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(9);
				break;
			case SO_LMULE:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(10);
				break;
			case SO_SHAREAZA:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(11);
				break;
			case SO_EDONKEYHYBRID:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(3);
				break;
			case SO_MLDONKEY:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(2);
				break;
			case SO_EMULE:
			case SO_OLDEMULE:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(1);
				break;
			case SO_EDONKEY:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(0);
				break;
			default:
				pNotify->ti->hIcon = uploadlistctrl.imagelist.ExtractIcon(8);
				break;
		}

		uploadlistctrl.SetFocus();
		//END Improved Tooltips
	}
///*	no tooltips needed ATM
	else if (control_id == IDC_QUEUELIST)
	{
		if (queuelistctrl.GetItemCount() < 1)
			return FALSE;
		int sel = GetItemUnderMouse(&queuelistctrl);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		CUpDownClient* client = (CUpDownClient*)uploadlistctrl.GetItemData(sel);
		in_addr server;
		server.S_un.S_addr = client->GetServerIP();

		info.Format(_T("Nickname: %s (UserID: %u)\n")
					_T("Client %s:%d\n")
					_T("Server %s:%d\n")
					_T("AskedCount: %d - AvailablePartCount: %d"),
					client->GetUserName(), client->GetUserID(),
					client->GetFullIP(), client->GetUserPort(), 
					inet_ntoa(server), client->GetServerPort(),
					client->GetAskedCount(), client->GetAvailablePartCount());

	}
//*/
//	m_strToolTip.ReleaseBuffer(); // release old used buffer
//	m_strToolTip = info;
	//BEGIN Improved Tooltips
	pNotify->ti->sTooltip = info;
	//pText->lpszText = m_strToolTip.GetBuffer(1);
	//pText->hinst = NULL; // we are not using a resource
	//PostMessage(WM_ACTIVATE);
	//END Improved Tooltips

	EMULE_CATCH

	return TRUE;
}

void CTransferWnd::SwitchUploadList()
{
	EMULE_TRY

	switch(m_nActiveWnd)
	{
		case 0:
		{	
			m_nActiveWnd = 1;
			rollupctrl.SetText(1, GetResString(IDS_ONQUEUE), true);
			uploadlistctrl.ShowWindow(SW_HIDE);
			rollupctrl.SetItemClient(1, &queuelistctrl);
			rollupctrl.Invalidate();
			break;
		}
		case 1:
		{	
			m_nActiveWnd = 0;
			rollupctrl.SetText(1, GetResString(IDS_RUP_UPLOADS), true);
			queuelistctrl.ShowWindow(SW_HIDE);
			rollupctrl.SetItemClient(1, &uploadlistctrl);
			rollupctrl.Invalidate();
			break;
		}
		default: break;
	}

	EMULE_CATCH
}

void CTransferWnd::Localize()
{
	EMULE_TRY

	downloadlistctrl.Localize();
	uploadlistctrl.Localize();
	queuelistctrl.Localize();
	infolistctrl.Localize();
	//Cax2 - localize the rollup control
	rollupctrl.SetText(0,GetResString(IDS_RUP_DOWNLOADS), true);
	rollupctrl.SetText(1,GetResString((m_nActiveWnd==0)?IDS_RUP_UPLOADS:IDS_ONQUEUE), true);
	rollupctrl.SetText(2,GetResString(IDS_RUP_INFO), true);
	if(m_bFirstShow)
	{
		m_bFirstShow = false;
		infolistctrl.SetColumn(theApp.glob_prefs->GetDetailColumnWidth());
	}

	EMULE_CATCH
}

void CTransferWnd::UpdateDownloadHeader()
{
	EMULE_TRY

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_DOWNINFO), theApp.downloadqueue->GetFileCount(),
						theApp.downloadqueue->GetTransferingFiles(),
							(float)theApp.downloadqueue->GetDatarate()/1024);
	rollupctrl.SetText(0, strBuffer);

	EMULE_CATCH
}
void CTransferWnd::UpdateUploadHeader()
{
	EMULE_TRY

	CString strBuffer;
	strBuffer.Format(GetResString(IDS_RUP_UPINFO), theApp.uploadqueue->GetWaitingUserCount(),
						theApp.uploadqueue->GetUploadQueueLength(), 
							theApp.uploadqueue->GetBanCount(),
								(float)theApp.uploadqueue->GetDatarate()/1024);
	rollupctrl.SetText(1, strBuffer);

	EMULE_CATCH
}
void CTransferWnd::UpdateInfoHeader()
{		
	EMULE_TRY

	CString strInfoHeader = _T("");

	switch(infolistctrl.GetType())
	{	
		case 1: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOUSER), infolistctrl.GetName()); 
			break;
		case 2: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOFILE), infolistctrl.GetName()); 
			break;
		default : 
			strInfoHeader = "";
			break;
	}
	
	rollupctrl.SetText(2, strInfoHeader);

	EMULE_CATCH
}

void CTransferWnd::InitRollupItemHeights()
{
	EMULE_TRY

	float fItemHeights[3][8];
		
	FILE *f;
	CString fullpath;
	fullpath.Format(_T("%sgui.dat"), theApp.glob_prefs->GetAppDir());
	f = _tfopen(fullpath, _T("rb"));	
	
	bool bUseDefault = false;

	if(f)
	{
		TCHAR cTemp[512];
		TCHAR *pToken;
        TCHAR seps[] = _T("|\n");

		for(int exp = 0; exp < 8; exp++)
		{
			if(!_fgetts(cTemp, 512, f))
			{
				bUseDefault = true;
				break;
			}

			float fTotalHeight = 0;
			pToken = _tcstok(cTemp, seps);
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					exp = 8;
					break;
				}

				fItemHeights[i][exp] = _tstof(pToken);
//				TRACE("fItemHeights[%d][%d] = %f\r\n", i, exp, _tstof(pToken));
				pToken = _tcstok(NULL, seps);

				if(fItemHeights[i][exp] < 0)	// this should never happen
				{
					bUseDefault = true;
					exp = 8;
					i = 3;
				}
				fTotalHeight += fItemHeights[i][exp];
			}
			
			// this should also never happen
			if(fTotalHeight >= 101 || fTotalHeight <= 99 && fTotalHeight != 0) // i'm very tolerant ;)
			{
				bUseDefault = true;
				exp = 8;
			}
		}	

		if(!_fgetts(cTemp, 512, f))
			bUseDefault = true;
//		TRACE("lastline = %s", cTemp);
		if(!bUseDefault)
		{
			pToken = _tcstok(cTemp, seps);
			
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					i = 3;
				}

				rollupctrl.ExpandItem(i, _tstoi(pToken));
				pToken = _tcstok(NULL, seps);
			}
		}
		
		fclose(f);
	}
	else
		bUseDefault = true;
	
	if(bUseDefault)
	{
	BYTE bExpandedItems; 

	bExpandedItems = 0x00;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x01;
	fItemHeights[0][bExpandedItems] = 100;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x02;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 100;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x03;
	fItemHeights[0][bExpandedItems] = 70;
	fItemHeights[1][bExpandedItems] = 30;
	fItemHeights[2][bExpandedItems] = 0;

	bExpandedItems = 0x04;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 100;

	bExpandedItems = 0x05;
	fItemHeights[0][bExpandedItems] = 70;
	fItemHeights[1][bExpandedItems] = 0;
	fItemHeights[2][bExpandedItems] = 30;

	bExpandedItems = 0x06;
	fItemHeights[0][bExpandedItems] = 0;
	fItemHeights[1][bExpandedItems] = 70;
	fItemHeights[2][bExpandedItems] = 30;

	bExpandedItems = 0x07;
	fItemHeights[0][bExpandedItems] = 50;
	fItemHeights[1][bExpandedItems] = 25;
	fItemHeights[2][bExpandedItems] = 25;
	}

	rollupctrl.SetItemHeights(0, fItemHeights[0], 8);
	rollupctrl.SetItemHeights(1, fItemHeights[1], 8);
	rollupctrl.SetItemHeights(2, fItemHeights[2], 8);

	EMULE_CATCH
}

void CTransferWnd::SafeRollupItemHeights()
{
	EMULE_TRY

	FILE *f;
	CString fullpath; // i_a
	fullpath.Format(_T("%sgui.dat"), theApp.glob_prefs->GetAppDir());
	f = _tfopen(fullpath, _T("wb"));	

	if(f)
	{
		for(int exp = 0; exp < 8; exp++)
		{	
			float f1,f2,f3;
			f1 = rollupctrl.GetItem(0)->pSizes[exp];
			f2 = rollupctrl.GetItem(1)->pSizes[exp];
			f3 = rollupctrl.GetItem(2)->pSizes[exp];
	
			// get rid off some rounding errors: ///
			if(f3)
				f3 = f1 ? (f2 ? (100 - f1 - f2) : (100 - f1)) : (100 - f2);
			else if(f2)
				f2 = 100 - f1;				
			////////////////////////////////////////

			fprintf(f, "%f|%f|%f\n", f1, f2, f3);
		}
		fprintf(f, "%d|%d|%d\n", rollupctrl.GetItem(0)->pHeader->IsExpanded(),
					rollupctrl.GetItem(1)->pHeader->IsExpanded(), rollupctrl.GetItem(2)->pHeader->IsExpanded());
		fclose(f);
	}

	EMULE_CATCH
}

BOOL CTransferWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
	{
		case USRMSG_SWITCHUPLOADLIST:
			SwitchUploadList();
			break;
		default: 
			break;
	}
	
	return CResizableDialog::OnCommand(wParam, lParam);
}
